addpath('/mnt/neocortex2/scratch/rmittelm/Work/liblinear-1.94/matlab');

tmp=load('PASCAL_datasets_TopicsYHDeep13.mat');

VIndices0_train = tmp.VIndices0_train;
VIndices0_test = tmp.VIndices0_test;
VIndices = tmp.VIndices;
VIndices_test = tmp.VIndices_test;

sgmVWpb0_train=tmp.features0_train;
sgmVWpb0_test=tmp.features0_test;
sgmVWpb=tmp.features_train;
sgmVWpb_test=tmp.features_test;

%Cs = 2**linspace(-12,5,20)
%Cs = 2**linspace(-12.5,-8.5,10)
num_of_processes=12;
m=20;
Cs = 2.^linspace(-10.5,-6.5,num_of_processes*m);
Cs=Cs(randperm(length(Cs)));

un=cell(num_of_processes,1);
Ctmp=cell(num_of_processes,1);
acc_cell=cell(num_of_processes,1);
acc2_cell=cell(num_of_processes,1);
for i=1:num_of_processes
    un{i}=unique(VIndices0_test);
    Ctmp{i}=Cs((i-1)*m+1:i*m);
end
acc=zeros(length(Cs),1);
acc2=zeros(length(Cs),1);
matlabpool(num_of_processes);
parfor i=1:num_of_processes
    acc_cell{i}=zeros(m,1);
    acc2_cell{i}=zeros(m,1);
    k=1;
    for c=Ctmp{i}
        model = train(VIndices0_train(:), sparse(sgmVWpb0_train),['-s 2 -B 1 -e 0.0001 -q -c ' num2str(c)]);
        [predicted_label, accuracy, bbb] = predict(VIndices0_test(:), sparse(sgmVWpb0_test), model);
        acc_cell{i}(k)=accuracy(1);
        ptmp=0;
        for j=un{i}(:).'
            ptmp=ptmp+sum(j==predicted_label(VIndices0_test==j))/length(find(VIndices0_test==j));
        end
        acc2_cell{i}(k)=ptmp/length(un{i});  
        [acc_cell{i}(k) acc2_cell{i}(k)]
        k=k+1;
    end
end
matlabpool close
for i=1:num_of_processes
    acc((i-1)*m+1:i*m)=acc_cell{i};
    acc2((i-1)*m+1:i*m)=acc2_cell{i};
end
[mx,ind]=max(acc); 
[mx,ind2]=max(acc2);

v=5; % correct for the different training and testing set sizes

model = train(VIndices(:), sparse(sgmVWpb),['-s 2 -B 1 -e 0.0001 -q -c ' num2str(Cs(ind)*(v-1)/v)]);
[predicted_label, accuracy, bbb] = predict( VIndices_test(:), sparse(sgmVWpb_test), model);
p_acc=accuracy(1);
model = train(VIndices(:), sparse(sgmVWpb),['-s 2 -B 1 -e 0.0001 -q -c ' num2str(Cs(ind2)*(v-1)/v)]);
[predicted_label, accuracy, bbb] = predict( VIndices_test(:), sparse(sgmVWpb_test), model);
ptmp=0;
for j=un{1}(:).'
    ptmp=ptmp+sum(j==predicted_label(VIndices_test==j))/length(find(VIndices_test==j));
end
p2_acc=ptmp/length(un{1});

overall_classifiction_rate=p_acc
mean_per_class_rate=p2_acc

save training_results.mat p_acc p2_acc
